<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::authDelegate::HttpPost Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.1.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><b>alexaClientSDK</b></li><li class="navelem"><b>authDelegate</b></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html">HttpPost</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::authDelegate::HttpPost Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>LIBCURL based implementation of <a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface.html" title="Minimal interface for making Http POST requests. ">HttpPostInterface</a>.  
 <a href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_http_post_8h_source.html">HttpPost.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::authDelegate::HttpPost:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1auth_delegate_1_1_http_post_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1auth_delegate_1_1_http_post_inherit__map" id="alexa_client_s_d_k_1_1auth_delegate_1_1_http_post_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface.html" title="Minimal interface for making Http POST requests. " alt="" coords="5,5,207,44"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::authDelegate::HttpPost:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1auth_delegate_1_1_http_post_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1auth_delegate_1_1_http_post_coll__map" id="alexa_client_s_d_k_1_1auth_delegate_1_1_http_post_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface.html" title="Minimal interface for making Http POST requests. " alt="" coords="5,5,207,44"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a648b8e15a2c5035a5a17458ff0288b17"><td class="memItemLeft" align="right" valign="top"><a id="a648b8e15a2c5035a5a17458ff0288b17"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html#a648b8e15a2c5035a5a17458ff0288b17">~HttpPost</a> ()</td></tr>
<tr class="memdesc:a648b8e15a2c5035a5a17458ff0288b17"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html" title="LIBCURL based implementation of HttpPostInterface. ">HttpPost</a> destructor. <br /></td></tr>
<tr class="separator:a648b8e15a2c5035a5a17458ff0288b17"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8987dedc8da7e8235009eb158e46b479"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html#a8987dedc8da7e8235009eb158e46b479">HttpPost</a> (const <a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html">HttpPost</a> &amp;rhs)=delete</td></tr>
<tr class="separator:a8987dedc8da7e8235009eb158e46b479"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a921308e837dcce64918a351c7d249e92"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html">HttpPost</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html#a921308e837dcce64918a351c7d249e92">operator=</a> (const <a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html">HttpPost</a> &amp;rhs)=delete</td></tr>
<tr class="separator:a921308e837dcce64918a351c7d249e92"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a99e704a8acaceaeae86227b1efc3d6b5"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html#a99e704a8acaceaeae86227b1efc3d6b5">doPost</a> (const std::string &amp;m_url, const std::string &amp;data, std::chrono::seconds timeout, std::string &amp;body) override</td></tr>
<tr class="separator:a99e704a8acaceaeae86227b1efc3d6b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface.html">alexaClientSDK::authDelegate::HttpPostInterface</a></td></tr>
<tr class="memitem:af9916832f0bd1839d9f2f0fe02808f00 inherit pub_methods_classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface"><td class="memItemLeft" align="right" valign="top"><a id="af9916832f0bd1839d9f2f0fe02808f00"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface.html#af9916832f0bd1839d9f2f0fe02808f00">~HttpPostInterface</a> ()=default</td></tr>
<tr class="memdesc:af9916832f0bd1839d9f2f0fe02808f00 inherit pub_methods_classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual destructor to assure proper cleanup of derived types. <br /></td></tr>
<tr class="separator:af9916832f0bd1839d9f2f0fe02808f00 inherit pub_methods_classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:aa78b1c3c7e2639e668f6ba1927630d47"><td class="memItemLeft" align="right" valign="top">static std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html">HttpPost</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html#aa78b1c3c7e2639e668f6ba1927630d47">create</a> ()</td></tr>
<tr class="separator:aa78b1c3c7e2639e668f6ba1927630d47"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_static_attribs_classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_static_attribs_classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface')"><img src="closed.png" alt="-"/>&#160;Static Public Attributes inherited from <a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface.html">alexaClientSDK::authDelegate::HttpPostInterface</a></td></tr>
<tr class="memitem:a34cb7604380d1bfab68f31bf93430297 inherit pub_static_attribs_classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface"><td class="memItemLeft" align="right" valign="top"><a id="a34cb7604380d1bfab68f31bf93430297"></a>
static const long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface.html#a34cb7604380d1bfab68f31bf93430297">HTTP_RESPONSE_CODE_UNDEFINED</a> = 0</td></tr>
<tr class="memdesc:a34cb7604380d1bfab68f31bf93430297 inherit pub_static_attribs_classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">The HTTP response code to use when the disposition of Post request is undefined. <br /></td></tr>
<tr class="separator:a34cb7604380d1bfab68f31bf93430297 inherit pub_static_attribs_classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a49f8089c821a1580577c68ba6be421e6 inherit pub_static_attribs_classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface"><td class="memItemLeft" align="right" valign="top"><a id="a49f8089c821a1580577c68ba6be421e6"></a>
static const long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface.html#a49f8089c821a1580577c68ba6be421e6">HTTP_RESPONSE_CODE_SUCCESS_OK</a> = 200</td></tr>
<tr class="memdesc:a49f8089c821a1580577c68ba6be421e6 inherit pub_static_attribs_classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">The HTTP response code for successful response. <br /></td></tr>
<tr class="separator:a49f8089c821a1580577c68ba6be421e6 inherit pub_static_attribs_classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>LIBCURL based implementation of <a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface.html" title="Minimal interface for making Http POST requests. ">HttpPostInterface</a>. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a8987dedc8da7e8235009eb158e46b479"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8987dedc8da7e8235009eb158e46b479">&#9670;&nbsp;</a></span>HttpPost()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::authDelegate::HttpPost::HttpPost </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html">HttpPost</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">delete</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Deleted copy constructor.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rhs</td><td>The 'right hand side' to not copy. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="aa78b1c3c7e2639e668f6ba1927630d47"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa78b1c3c7e2639e668f6ba1927630d47">&#9670;&nbsp;</a></span>create()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html">HttpPost</a> &gt; alexaClientSDK::authDelegate::HttpPost::create </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Create a new <a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html" title="LIBCURL based implementation of HttpPostInterface. ">HttpPost</a> instance, passing ownership of the new instance on to the caller.</p>
<dl class="section return"><dt>Returns</dt><dd>Retruns an std::unique_ptr to the new <a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html" title="LIBCURL based implementation of HttpPostInterface. ">HttpPost</a> instance, or <code>nullptr</code> of the operation failed. </dd></dl>

</div>
</div>
<a id="a99e704a8acaceaeae86227b1efc3d6b5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a99e704a8acaceaeae86227b1efc3d6b5">&#9670;&nbsp;</a></span>doPost()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">long alexaClientSDK::authDelegate::HttpPost::doPost </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>url</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::chrono::seconds&#160;</td>
          <td class="paramname"><em>timeout</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string &amp;&#160;</td>
          <td class="paramname"><em>body</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Perform an HTTP Post request returning the response body as a string. This method blocks for the duration of the request.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">url</td><td>The URL to send the POST to. </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">data</td><td>The POST data to send in the request. </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">timeout</td><td>The maximum amount of time (in seconds) to wait for the request to complete. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">body</td><td>A string to receive the body of the request if there is one. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A HttpStatus indicating the disposition of the Post request. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post_interface.html#a16c7184b5dec9292db1db981e9d64fec">alexaClientSDK::authDelegate::HttpPostInterface</a>.</p>

</div>
</div>
<a id="a921308e837dcce64918a351c7d249e92"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a921308e837dcce64918a351c7d249e92">&#9670;&nbsp;</a></span>operator=()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html">HttpPost</a>&amp; alexaClientSDK::authDelegate::HttpPost::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classalexa_client_s_d_k_1_1auth_delegate_1_1_http_post.html">HttpPost</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">delete</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Deleted assignment operator.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rhs</td><td>The 'right hand side' to not copy. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The object assigned to. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/Users/sdy/AVS_CPP_SDK/github/alexa-client-sdk/AuthDelegate/include/AuthDelegate/<a class="el" href="_http_post_8h_source.html">HttpPost.h</a></li>
<li>/Users/sdy/AVS_CPP_SDK/github/alexa-client-sdk/AuthDelegate/src/HttpPost.cpp</li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.1.0 - Copyright 2016-2017 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
